// Finders
let MainBox = document.getElementById('MainBox');
let ProgressPercent = document.getElementById('ProgressPercent');

// Dynamic Variables
let RequireMultipleClicks = true;
let PlaySound = true;
let ShowPercent = true;
let ShowFlame = true;
let HeaderText = 'You can change this header in the export call! :) ApolloStudios#4510';
let BoxColor = '#62d0f7';

function Add36BoxesToMainBox() {

    // remove all children
    while (MainBox.firstChild) {
        MainBox.removeChild(MainBox.firstChild);
    }

    for (let i = 0; i < 36; i++) {
        let Box = document.createElement('div');
        Box.className = 'block';
        MainBox.appendChild(Box);

        // set box background
        Box.style.backgroundColor = BoxColor;

        // [!] Flame
        if (ShowFlame) {
            let Img = document.createElement('img');
            Img.src = "./FLAME_WHITE.png";
            Img.className = 'img';
            Box.appendChild(Img);
            Img.width = 12;
            Img.style.position = 'absolute';
            Img.style.marginLeft = '5px';
            Img.style.marginTop = '5px';
            Img.style.webkitUserSelect = 'none';
        }


        // slowly fade in each box
        setTimeout(function () {
            Box.style.opacity = 1;
        }, i * 50);


        // Check if box exists
        Box.id = i;

        // Add a click event to each box
        Box.addEventListener('click', function () {

            if (Box.id == '') {
                return;
            }

            // 25% chance
            if (RequireMultipleClicks) {
                if (Math.random() < 0.35) {
                    Box.id = '';
                    Box.style.opacity = 0
                    UpdateProgessBar();
                }
            } else {
                Box.id = '';
                Box.style.opacity = 0
                UpdateProgessBar();
            }

            if (PlaySound) {
                let audio = new Audio('./pop.mp3');
                audio.volume = 0.01;
                audio.play();
            }
        });
    }
}

function UpdateProgessBar() {

    let Boxes = document.getElementsByClassName('block');
    let BoxesLeft = 0;
    for (let i = 0; i < Boxes.length; i++) {
        if (Boxes[i].id != '') {
            BoxesLeft++;
        }
    }

    // Update the progress bar
    if (ShowPercent) {
        ProgressPercent.style.display = 'block';
        let Percent = Math.round((BoxesLeft / 36) * 100);
        ProgressPercent.innerHTML = Percent + '%';
    }

    if (BoxesLeft == 0) {
        $.post(`https://Apollo-Minigame/Apollo-callback`, JSON.stringify({ 'success': true }));
    }
}

function ChangeHeader() {
    let Header = document.getElementById('HeaderText');
    Header.innerHTML = HeaderText;
}

function HideScreen() {
    let Screen = document.getElementById('ApolloMinigame');
    Screen.style.display = 'none';
}

function ShowScreen() {
    let Screen = document.getElementById('ApolloMinigame');
    Screen.style.display = 'block';
}

document.addEventListener("keydown", function(ev) {
    let key_pressed = ev.key;
    let valid_keys = ['Escape'];
  
    if (valid_keys.includes(key_pressed)) {
        switch (key_pressed) {
            case 'Escape':
                ResetThermite();
                $.post(`https://Apollo-Minigame/Apollo-callback`, JSON.stringify({ 'success': false }));
                break;
        }
    }
  });

// [!] Apollo Listener
$(document).ready(function () {
    window.addEventListener("message", function (event) {
      var data = event.data;
        if (data.type == "open") {
            RequireMultipleClicks = data.RequireMultipleClicks;
            PlaySound = data.PlaySound;
            ShowPercent = data.ShowPercent;
            ShowFlame = data.ShowFlame;
            HeaderText = data.HeaderText;
            BoxColor = data.BoxColor;
            ShowScreen();
            Add36BoxesToMainBox();
            UpdateProgessBar();
            ChangeHeader();
        }
        if (data.type == "close") {
            HideScreen();
        }
    });
});